#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef char AirportCode[4];
typedef struct NodeTag {
                        AirportCode Airport;
                        struct NodeTag *Link;
                } NodeType;
typedef NodeType *NodePointer;

void InsertNewLastNode(char *A, NodeType **L)
{
      NodeType *N, *P;

      N=(NodeType *)malloc(sizeof(NodeType));
      strcpy(N->Airport, A);
      N->Link=NULL;

      if (*L == NULL) {
         *L=N;
      } else {
         P=*L;
         while (P->Link != NULL) P=P->Link;
         P->Link=N;
      }

}


void PrintList(NodeType *L)
{
      NodeType *N;

      printf("(");
      N=L;
      while(N != NULL) {
         printf("%s", N->Airport);
         N=N->Link;
         if (N!=NULL) printf(",");
      }
      printf(")\n");
}


void Reverse(NodeType **L)
{
   NodeType *Prev, *Cur, *TempCur;

   Cur = *L;
   Prev = NULL;

   while (Cur != NULL) {
      TempCur = Cur;
      Cur = Cur->Link;
      TempCur->Link = Prev;
      Prev = TempCur;
   }
   *L = Prev;
}



int main(void)
{
      NodeType *A;

      A=NULL;

      InsertNewLastNode("DUS", &A);
      InsertNewLastNode("ORD", &A);
      InsertNewLastNode("SAN", &A);
      PrintList(A);

      Reverse(&A);

      PrintList(A);
}
